#
#   Twisted Pynfo - A relay, info, and search bot for IRC.
#   Copyright (C) 2002 Jp Calderone (exarkun@twistedmatrix.com)
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA
#

from Pynfo import interfaces

def info_PASSWORD(bot, user, channel, args):
    """Usage: password <password> - Respond to a password authentication challenge."""
    c = bot.getComponent(interfaces.IAuthenticator)
    if hasattr(c, 'checkResponse'):
        c.checkResponse(user, args)
    else:
        bot.reply(user, 'Password authentication is not currently enabled.')

def privinfo_SETPWD(bot, user, channel, args):
    """Usage: setpwd <new password> - Change your password."""
    bot.network.passwords[user] = args
    bot.reply(user, 'Password changed.')

def secure_RESETPWD(bot, user, channel, args):
    """Usage: resetpwd <user>[@<network>] <new password> - Change any user's password on any network"""
    args = args.split(None, 1)
    if len(args) != 2:
        bot.reply(user, 'Incorrect usage.  See "help resetpwd"')
        return

    where, what = args
    args = where.split('@', 1)
    if len(args) == 2:
        who, net = args
        try:
            net = bot.factory.networkByAlias(net)
        except KeyError:
            bot.reply(user, 'There is no such network.')
            return
    else:
        net = bot.network

    net.passwords[who] = what
    bot.reply(user, 'Password changed.')
